####################
# make plone 2.1 can support Japanese
#####################
from Products.CMFPlone import PloneTool
import re

PloneTool.BAD_CHARS = re.compile(r'[^a-zA-Z0-9-_~,.$\(\)# ]%').findall


# use Japanese id when you input Japanese in title.
def normalizeString(self, text):
    if not isinstance(text, basestring):
        text = repr(text)
    return text

from Products.CMFPlone.PloneTool import PloneTool
PloneTool.normalizeString = normalizeString


# replace special characters in URL using the "%xx" escape
# when you download a file in Plone if the useragent is MSIE.
from Products.Archetypes.utils import contentDispositionHeader
from urllib import quote

def download(self, instance, REQUEST=None, RESPONSE=None):
    """Kicks download.
    Writes data including file name and content type to RESPONSE
    """
    file = self.get(instance)
    if not REQUEST:
        REQUEST = instance.REQUEST
    useragent =  REQUEST['HTTP_USER_AGENT']
    MSIE = useragent.find('MSIE')
    if not RESPONSE:
        RESPONSE = REQUEST.RESPONSE
    filename = self.getFilename(instance)
    if filename is not None:
        if MSIE >= 0:
            filename=quote(filename)
        header_value = contentDispositionHeader('attachment', instance.getCharset(), filename=filename)
        RESPONSE.setHeader("Content-disposition", header_value)
    return file.index_html(REQUEST, RESPONSE)

from Products.Archetypes.Field import FileField
FileField.download = download
